float opacity : register(C0);
float2 pixelSize : register(C1);
sampler2D  ImageSampler : register(S0); 

float PixelKernel[13] =
{
   -6,
   -5,
   -4,
   -3,
   -2,
   -1,
    0,
    1,
    2,
    3,
    4,
    5,
    6,
};

static const float BlurWeights[13] =
{
   0.002216,
   0.008764,
   0.026995,
   0.064759,
   0.120985,
   0.176033,
   0.199471,
   0.176033,
   0.120985,
   0.064759,
   0.026995,
   0.008764,
   0.002216,
};

float4 PS1( float2 uv : TEXCOORD) : COLOR
{
	float4 color = 0;
	float2 samp = uv;
	samp.y = uv.y;

	for (int i = 0; i < 13; i++) {
		samp.x = uv.x + PixelKernel[i] * pixelSize.x;
		color += tex2D(ImageSampler, samp.xy) * BlurWeights[i];
	}

	return color;
}

float4 PS2( float2 uv : TEXCOORD) : COLOR
{
	float4 color = 0;
	float2 samp = uv;
	samp.x = uv.x;

	for (int i = 0; i < 13; i++) {
		samp.y = uv.y + PixelKernel[i] * pixelSize.y;
		color += tex2D(ImageSampler, samp.xy) * BlurWeights[i];
	}

	return color;
}

technique Default
{
	pass P0
	{
		AlphaBlendEnable = TRUE;
		DestBlend = INVSRCALPHA;
		SrcBlend = SRCALPHA;
		PixelShader = compile ps_2_0 PS1();
	}

	pass P1
	{
		AlphaBlendEnable = TRUE;
		DestBlend = INVSRCALPHA;
		SrcBlend = SRCALPHA;
		PixelShader = compile ps_2_0 PS2();
	}	

}