float opacity : register(C0);
sampler2D Texture1Sampler : register(S0);
Texture2D g_texture : register(t0);

struct	PS_Input
{
	float4 posH	: SV_POSITION;
	float2 texcoord	: TEXCOORD;
};

float4 PS(PS_Input v ) : COLOR
{
    float4 color = tex2D(Texture1Sampler, v.texcoord);
    float4 bshift = float4(0.03,0.0,0.25,0);
    float4 oshift = float4(0.68,0.6,0.51,1);
    float4 pshift = float4(0.99,0.82,0.92,1);
    float4 b2shift = float4(0.03,0.0,0.26,0);
    
    float4 originalColor = float4(color.r,color.g,color.b,color.a);
    
    // Perform exclusion
    color = 0.5 - 2.0 * (color.rgba - 0.5) * (bshift - 0.5);

    float4 minInput = float4(0.1,0.1,0.1,0);
    float4 maxInput = float4(1,1,1,1);
    
    // Levels adjustment
    color = max(color - minInput, 0.0) / (maxInput - minInput);
    color = min(color, 1.0);
    
    // Soft light
    //if (any(oshift.rgba) < 0.5)
    //	color = 1.0 - (1.0 - color) * (1 - 2 * (oshift - 0.5));
    //else
	color = color * (2.0 * oshift);
    
    //color = color * (pshift);
    
    color = 0.5 - 2.0 * (color.rgba - 0.5) * (b2shift - 0.5);
       
    //color.rgb = ((color.rgb - 0.5f) * max(0.85, 0)) + 0.5f;
    
    color = color + (originalColor * 0.05);

    color = color - 0.05;
  	
    float fGrey = dot(color, float3(0.3, 0.59, 0.11));
    color.rgb = lerp(fGrey, color, 0.95).rgb;

    // Contrast
    //color.rgb = ((color.rgb - 0.5f) * max(1.1, 0)) + 0.5f;

    // Vignette
    float2 dist = v.texcoord - 0.5f;
    dist.x = 1.0f - dot(dist, dist);
    color.rgb *= saturate(pow(dist.x, 3.0f));

    color.a = color.a * opacity;
	
    return color;
}

technique Default
{
	pass P0
	{
		AlphaBlendEnable = TRUE;
	    DestBlend = INVSRCALPHA;
	    SrcBlend = SRCALPHA;
		PixelShader = compile ps_2_0 PS();
	}
}




